
#=============================================================================
# clippic_common.pl: Perl library for clippic (ver.20040313)
#
# Copyright (C) 2004 OHKUBO Masahiko <mah@pobox.ne.jp>
# The latest version is available here: http://mah.pobox.ne.jp/clippic.shtml
#=============================================================================

use strict;
use vars '%setting';

$setting{'program_name'} = 'clippic';
$setting{'program_version'} = '20040313';
$setting{'program_author'} = 'OHKUBO Masahiko';
$setting{'program_url'} = 'http://mah.pobox.ne.jp/clippic.shtml';
$setting{'seconds_filelock'} = 30;



# ǥեͤΥå (ΤΤߡ%setting ȿǤ)
sub SET_SETTING_DEFAULT {
	my($mode) = @_;
	my(%base, %tmp, $ref_output);

	# 
	%base = (
		'program_name' => '',
		'program_version' => '',
		'program_author' => '',
		'program_url' => '',
		'seconds_filelock' => '',
		'date' => '',
		'time' => '',
		'dir_program' => '',
		'file_program' => '',
		'dir_data' => '',
		'cleanup_log' => '1',
		'cleanup_log_flag' => 'yet',
		'debug' => '',
		'debug_log' => '',
		'quiet' => '',
		'verbose_level_stdout' => 1,
		'verbose_level_log' => 1,
		'verbose_jcode_stdout' => 'euc', #<perl2exe_comment>
		'verbose_jcode_log' => 'euc', #<perl2exe_comment>
#		'verbose_jcode_stdout' => 'sjis', #<perl2exe_execute>
#		'verbose_jcode_log' => 'sjis', #<perl2exe_execute>
	);
	if ($mode eq 'mail') {
		# clippic_mail.pl
		%tmp = (
			'file_log' => 'clippic_mail.log',
			'file_input' => '',
			'seconds_net' => '50',
			'cleanup_uidl' => 10000,
			'input_byte_max' => 256 * 1024,
			'check_module_netpop3' => '',
			'check_module_netftp' => '',
			'version_module_netpop3' => '2.23',
			'version_module_netftp' => '2.65',
			'file_data' => 'clippic_mail_user.cgi',
			'dir_data_pop' => '.pop/',
			'mode' => '',
			# (: <http://www.din.or.jp/~ohzaki/perl.htm#Mail>)
			'mail_address_regex' =>
				q{(?:[^(\040)<>@,;:".\\\\\[\]\000-\037\x80-\xff]+(?![^(\040)<>@,;:".\\\\} .
				q{\[\]\000-\037\x80-\xff])|"[^\\\\\x80-\xff\n\015"]*(?:\\\\[^\x80-\xff][} .
				q{^\\\\\x80-\xff\n\015"]*)*")(?:\.(?:[^(\040)<>@,;:".\\\\\[\]\000-\037\x} .
				q{80-\xff]+(?![^(\040)<>@,;:".\\\\\[\]\000-\037\x80-\xff])|"[^\\\\\x80-} .
				q{\xff\n\015"]*(?:\\\\[^\x80-\xff][^\\\\\x80-\xff\n\015"]*)*"))*@(?:[^(} .
				q{\040)<>@,;:".\\\\\[\]\000-\037\x80-\xff]+(?![^(\040)<>@,;:".\\\\\[\]\0} .
				q{00-\037\x80-\xff])|\[(?:[^\\\\\x80-\xff\n\015\[\]]|\\\\[^\x80-\xff])*} .
				q{\])(?:\.(?:[^(\040)<>@,;:".\\\\\[\]\000-\037\x80-\xff]+(?![^(\040)<>@,} .
				q{;:".\\\\\[\]\000-\037\x80-\xff])|\[(?:[^\\\\\x80-\xff\n\015\[\]]|\\\\[} .
				q{^\x80-\xff])*\]))*},
		);
		$ref_output = &MARGE_HASH(\%base, \%tmp);
	}
	if ($mode eq 'list') {
		# clippic_list.cgi
		%tmp = (
			'file_data' => 'clippic_list_user.cgi',
			# (: <http://www.din.or.jp/~ohzaki/perl.htm#httpURL>)
			'url_http_regex' =>
				q{\b(?:https?|shttp)://(?:(?:[-_.!~*'()a-zA-Z0-9;:&=+$,]|%[0-9A-Fa-f} .
				q{][0-9A-Fa-f])*@)?(?:(?:[a-zA-Z0-9](?:[-a-zA-Z0-9]*[a-zA-Z0-9])?\.)} .
				q{*[a-zA-Z](?:[-a-zA-Z0-9]*[a-zA-Z0-9])?\.?|[0-9]+\.[0-9]+\.[0-9]+\.} .
				q{[0-9]+)(?::[0-9]*)?(?:/(?:[-_.!~*'()a-zA-Z0-9:@&=+$,]|%[0-9A-Fa-f]} .
				q{[0-9A-Fa-f])*(?:;(?:[-_.!~*'()a-zA-Z0-9:@&=+$,]|%[0-9A-Fa-f][0-9A-} .
				q{Fa-f])*)*(?:/(?:[-_.!~*'()a-zA-Z0-9:@&=+$,]|%[0-9A-Fa-f][0-9A-Fa-f} .
				q{])*(?:;(?:[-_.!~*'()a-zA-Z0-9:@&=+$,]|%[0-9A-Fa-f][0-9A-Fa-f])*)*)} .
				q{*)?(?:\?(?:[-_.!~*'()a-zA-Z0-9;/?:@&=+$,]|%[0-9A-Fa-f][0-9A-Fa-f])} .
				q{*)?(?:#(?:[-_.!~*'()a-zA-Z0-9;/?:@&=+$,]|%[0-9A-Fa-f][0-9A-Fa-f])*} .
				q{)?},
		);
		$ref_output = &MARGE_HASH(\%base, \%tmp);
	}
	return($ref_output);
}



# ϥå򤯤äĤ
sub MARGE_HASH {
	my($ref_base, $ref_tmp) = @_;
	my($key, $value);

	while (($key, $value) = each(%$ref_tmp)) {
		$$ref_base{$key} = $value;
	}
	return($ref_base);
}



# ٥˽äơåɽȥϿԤ (error=顼normal=̡detail=ܺ١nothing=⤷ʤ)
sub VERBOSE {
	my($level_stdout, $level_log, $message) = @_;
	my(%level) = ('error' => 0, 'normal' => 1, 'detail' => 2, 'nothing' => 9);

	$level_stdout = $level{$level_stdout};
	$level_log = $level{$level_log};
	# åɽ
	if ($level_stdout <= $setting{'verbose_level_stdout'}) {
		if ($setting{'verbose_jcode_stdout'} ne 'euc') {
			jcode::convert(\$message, $setting{'verbose_jcode_stdout'}, 'euc');
		}
		if ($level_stdout > 0) {
			print $message . "\n";
		} else {
			warn $message . "\n";
		}
	}
	# Ͽ
	if ($level_log <= $setting{'verbose_level_log'}) {
		if ((defined($setting{'cleanup_log'})) && (defined($setting{'cleanup_log_flag'}))) {
			if (($setting{'cleanup_log'} >= 0) && ($setting{'cleanup_log_flag'} eq 'yet')) {
				$setting{'cleanup_log_flag'} = &CLEANUP_LOG($setting{'file_log'}, $setting{'cleanup_log'});
			}
		}
		$message =~ s/\x0D\x0A/<0D><0A>/g;	# \n in SMTP, Windows
		$message =~ s/\x0A/<0A>/g;	# \n in UNIX
		$message =~ s/\x0D/<0D>/g;	# \n in Macintosh
		&SAVE_LOG($setting{'file_log'}, $message);
	}
	if (($level_stdout * $level_log) == 0) {
		exit(0);
	}
	return;
}



# Ͽ
sub SAVE_LOG {
	my($file, $line) = @_;
	my($file_rename);

	$file_rename = &LOCK_FILE($file);
	open(FILE_LOG, ">>$file_rename");
	chmod(oct('600'), $file_rename);
	if ($setting{'verbose_jcode_log'} ne 'euc') {
		jcode::convert(\$line, $setting{'verbose_jcode_log'}, 'euc');
	}
	($setting{'date'}, $setting{'time'}) = (&GET_DATE())[0,1];
	print FILE_LOG '[' . $setting{'date'} . ',' . $setting{'time'} . ',' . sprintf('%05d', $$) . '] ' . $line . "\n";
	close(FILE_LOG);
	&UNLOCK_FILE($file_rename);
	return;
}



# ݽ
sub CLEANUP_LOG {
	my($file, $day_alive) = @_;
	my($file_rename, $file_tmp, $line, $date_log, $date_now, $date_border, $flag);
	my($day, $mon, $year);

	$file_rename = &LOCK_FILE($file);
	(undef, undef, undef, $day, $mon, $year, undef, undef, undef) = localtime((stat($file_rename))[9]);
	$date_log = sprintf('%04d%02d%02d', $year + 1900, $mon + 1, $day);
	$date_now = (&GET_DATE())[0];
	$date_now = substr($date_now, 0, 4) . substr($date_now, 5, 2) . substr($date_now, 8, 2);
	if ($date_log ne $date_now) {
		# κǽä
		(undef, undef, undef, $day, $mon, $year, undef, undef, undef) = localtime(time - $day_alive * 86400);
		$date_border = sprintf('%04d%02d%02d', $year + 1900, $mon + 1, $day);
		$file_tmp = $file . '.writing';
		open(FILE_LOG1, "$file_rename");
		open(FILE_LOG2, ">$file_tmp");
		chmod(oct('600'), $file_tmp);
		while (defined($line = <FILE_LOG1>)) {
			$date_log = substr($line, 1, 4) . substr($line, 6, 2) . substr($line, 9, 2);
			if ($date_log >= $date_border) {
				print FILE_LOG2 $line;
			}
		}
		close(FILE_LOG2);
		close(FILE_LOG1);
		rename($file_tmp, $file);	# ξ̤ˡǥåե
		unlink($file_rename);
		&VERBOSE('normal', 'normal', 'CLEANUP(log): day_alive = ' . $day_alive . '; file = ' . $file . ';');
		$flag = 'done';
	} else {
		&UNLOCK_FILE($file_rename);
		$flag = 'pass';
	}
	return($flag);
}



# եå
sub LOCK_FILE {
	my($file) = @_;
	my($counter, $dir, $file_rename, $file_lock, $time);
	my($file_base, $file_dummy, @tmp, @file);

	if (index($file, '/') > -1) {
		$file =~ /(.*)\/(.*)$/;
		$dir = $1 . '/';
		$file_base = '^' . quotemeta($2);
	} else {
		$dir = './';
		$file_base = '^' . quotemeta($file);
	}
	$file_lock = $file_base . '\.lock_(\d+)';

	if (scalar(&LOCK_FILE_GREP($dir, $file_base)) == 0) {
		# äݤեϲ˺ (ִŪʷ꤬)
		open(FILE_LOCK, ">$file");
		chmod(oct('600'), $file);
		close(FILE_LOCK);
	}
	# ¸եФơեåߤ
	for ($counter = 0; $counter < $setting{'seconds_filelock'}; $counter ++) {
		$file_rename = $file . '.lock_' . time;
		if (rename($file, $file_rename)) {
			return($file_rename);
		}
		&VERBOSE('normal', 'nothing', 'SLEEP(' . ($counter + 1). '/' . $setting{'seconds_filelock'}. '): waiting lock file = ' . $file);
		sleep(1);
	}
	# եåǤʤäΤ
	@file = &LOCK_FILE_GREP($dir, $file_lock);
	while (@file) {
		$file_lock = $dir . shift(@file);
		$file_lock =~ /\.lock_(\d+)$/;
		$time = $1;
		$file_rename = $file . '.lock_' . time;
		if (((time - $time) > $setting{'seconds_filelock'} * 2) && (rename($file_lock, $file_rename))) {
			return($file_rename);
		}
	}
	&VERBOSE('error', 'nothing', 'ERROR: cannot lock file = ' . $file);
	return(undef);
}
sub LOCK_FILE_GREP {
	my($dir, $file_lock) = @_;
	my(@file);

	opendir(DIR_LOCK, $dir);
	@file = grep(/$file_lock/, readdir(DIR_LOCK));
	closedir(DIR_LOCK);
	return(@file);
}



# եΥå򳰤
sub UNLOCK_FILE {
	my($file_rename) = @_;
	my($file, $time);

	$file = $file_rename;
	$file_rename =~ /\.lock_(\d+)$/;
	$time = $1;
	$file =~ s/\.lock_$time$//;
	rename($file_rename, $file);
	return;
}



# ߤա
sub GET_DATE {
	$ENV{'TZ'} = 'JST-9';
	my($sec, $min, $hour, $day, $mon, $year, $wday, $yday, $isdst);
	my($date, $time, $rfc_jst, $rfc_gmt);
	my(@weekday) = ('Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat');
	my(@month) = ('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec');

	# GMT
	($sec, $min, $hour, $day, $mon, $year, $wday, $yday, $isdst) = gmtime;
	$time = sprintf('%02d:%02d:%02d', $hour, $min, $sec);
	$day = sprintf('%02d', $day);
	$rfc_gmt = $weekday[$wday] . ', ' . $day . ' ' . $month[$mon] . ' ' . ($year + 1900) . ' ' . $time . ' GMT';
	# JST
	($sec, $min, $hour, $day, $mon, $year, $wday, $yday, $isdst) = localtime;
	$date = sprintf('%04d/%02d/%02d', $year + 1900, $mon + 1, $day);
	$time = sprintf('%02d:%02d:%02d', $hour, $min, $sec);
	$day = sprintf('%02d', $day);
	$rfc_jst = $weekday[$wday] . ', ' . $day . ' ' . $month[$mon] . ' ' . ($year + 1900) . ' ' . $time . ' +0900';
	return($date, $time, $rfc_jst, $rfc_gmt);
}



# ƥȥեɤ߹
sub LOAD_FILE {
	my($file, $mode) = @_;
	my($text, $ref_text, $code, @text);

	$/ = undef;
	open(FILE, $file) || &VERBOSE('error', 'error', 'ERROR: cannot open - file = ' . $file);
	$text = <FILE>;
	close(FILE);
	$/ = "\n";
	if ($mode ne 'direct') {
		($ref_text, $code) = &CONVERT_EUC(\$text);
		$text = $$ref_text;
	}
	@text = split("\n", $text);
	return(\@text, $code);
}



# եɤ߹
sub LOAD_CONFIGFILE {
	my($file, $mode) = @_;
	my($line, $section, $key, $value, %output, $ref_text);
	my($flag_cache, $ref_output);

	if ($mode ne 'direct') {
		($flag_cache, $ref_output) = &LOAD_FILE_CACHE($file);
	}
	if ($flag_cache ne 'yes') {
		# եɤ߹ߤʤ
		&VERBOSE('detail', 'detail', 'LOAD(config): file = ' . $file);
		$ref_text = (&LOAD_FILE($file))[0];
		while (@$ref_text) {
			$line = shift(@$ref_text);
			if ((!($line =~ /^\s*#/)) && (!($line =~ /^\s*$/))) {
				# # ǻϤޤäƤԡԤɤФ
				$line = ${&CUT_SPACE_TERMINAL(\$line)};
				if ($line =~ /^\[(.*)\]$/) {
					# [HOGEHOGE] ιԤ
					$section = $1;
					$section =~ tr/A-Z/a-z/;
				} else {
					($key, $value) = split(/\s*=\s*/, $line, 2);
					$key =~ tr/A-Z/a-z/;
					$output{$key . ':' . $section} = $value;
				}
			}
		}
		if ($mode ne 'direct') {
			&SAVE_FILE_CACHE($file, \%output);
		}
		$ref_output = \%output;
	}
	return($ref_output);
}



# ܸ EUC Ѵԥɤ줹
sub CONVERT_EUC {
	my($ref_text) = @_;
	my($code);

	$code = jcode::getcode($ref_text);
	if (($code eq 'jis') || ($code eq 'sjis')) {
		jcode::convert($ref_text, 'euc', $code);
	}
	$$ref_text =~ s/\x0D\x0A/\n/g;
	$$ref_text =~ tr/\x0D\x0A/\n\n/;
	return($ref_text, $code);
}



# ξüΥڡ򥫥åȤ
sub CUT_SPACE_TERMINAL {
	my($ref_line) = @_;

	$$ref_line =~ s/^\s+//;
	$$ref_line =~ s/\s+$//;
	return($ref_line);
}



# ƥץ졼Ȥɤ߹
sub LOAD_TEMPLATE {
	my($file) = @_;
	my($text, $file_cache, $file_rename);

	$file_cache = &CONVERT_FILENAME_CACHE($file);
	if (-e ($file)) {
		if ((-w ($file_cache)) && ((-M ($file)) > (-M ($file_cache)))) {
			# ʬǹǽʥåե뤬ꡤ줬ե꿷
			$/ = undef;
			open(FILE, $file_cache);
			$text = <FILE>;
			close(FILE);
			$/ = "\n";
		} else {
			$/ = undef;
			open(FILE, $file);
			$text = <FILE>;
			close(FILE);
			$/ = "\n";
			# åե¸
			$text = ${(&CONVERT_EUC(\$text))[0]};
			$file_rename = &LOCK_FILE($file_cache);
			open(FILE, ">$file_rename");
			chmod((stat($file))[2], $file_rename);
			print FILE $text;
			close(FILE);
			&UNLOCK_FILE($file_rename);
		}
	} else {
		&VERBOSE('error', 'error', 'ERROR: file not found. / file = ' . $file . ';');
	}
	return(\$text);
}



# ƥץ졼Ȥִ
sub REPLACE_STRING_HTML {
	my($ref_text, $ref_data) = @_;
	my($tmp1, $tmp2, $tmp3);

	# ƥ
	$$ref_data{'_PROGRAM_NAME_'} = $setting{'program_name'};
	$$ref_data{'_PROGRAM_VERSION_'} = $setting{'program_version'};
	$$ref_data{'_PROGRAM_AUTHOR_'} = $setting{'program_author'};
	$$ref_data{'_PROGRAM_URL_'} = $setting{'program_url'};
	($$ref_data{'_DATE_'}, $$ref_data{'_TIME_'}) = &GET_DATE();
	# ѿִ
	foreach $tmp1 (keys(%$ref_data)) {
		$tmp3 = $$ref_data{$tmp1};
		$tmp2 = '<#' . $tmp1 . '#>';
		$$ref_text =~ s/$tmp2/$tmp3/g;
	}
	# ;äѿϥå
	$$ref_text =~ s/<#\S+#>//g;
	return($ref_text);
}



# åեκ߽衦̾
sub CONVERT_FILENAME_CACHE {
	my($file) = @_;

	$file =~ /(.+)\/([^\/]+)$/;
	return($1 . '/.cache_' . $2);
}



1;
